<template>
  <div class="login">
    <div class="login_text">Login</div>
    <input
      class="login_input"
      placeholder="email"
      type="email"
      v-model="email"
    />

    <input
      class="login_input"
      placeholder="senha"
      type="password"
      v-model="password"
    />

    <button class="login_button" type="submit" @click="login" @submit.prevent>
      Login
    </button>
  </div>
</template>

<script>
import { mapGetters } from 'vuex';

export default {
  data() {
    return {
      email: '',
      password: ''
    }
  },

  methods: {
    async login() {
      const response = await this.$axios.$post(`/rpc/autenticar`, {
        email: this.email,
        senha: this.password
      });

      // Save token at global vuex store to be used by auth middleware
      this.$store.commit('setToken', { token: response });
      this.$store.commit('setEmail', { email: this.email });
      this.$store.commit('setPlanNumber', { planNumber: 1})

      this.$store.dispatch('getNome');

      await this.$store.dispatch('getNusp');

      this.$store.dispatch('getStartingYear');

      this.$store.dispatch('getSubjects', {
        payload: {
          nusp_aln: this.getNusp
        },
        url: 'disciplinas_aprovadas',
        setter: 'setApprovedSubjects',
        name: 'approvedSubjects'
      });

      this.$store.dispatch('getSubjects', {
        payload: {
          nusp_aln: this.getNusp
        },
        url: 'nome_disciplinas_bloqueadas',
        setter: 'setBlockedSubjects',
        name: 'blockedSubjects'
      });

      const sub_types = ['obrigatorios', 'eletivos', 'livres'];
      let responses = [];
      let baseRPCUrl = '/rpc/busca_';
      let payload = { nusp_aln: this.getNusp }

      for (let i in sub_types) {
        const response =
          await this.$axios.$post(`${baseRPCUrl}${sub_types[i]}`, payload)
        responses.push(response);
      }

      this.$store.commit('setCredits', {
        cred_obg: responses[0],
        cred_el: responses[1],
        cred_livre: responses[2]
      }),

      this.$store.dispatch('getPlans');
    }
  },

  computed: {
    ...mapGetters([
      'getNusp',
      'getPlanNumber'
    ])
  }
}
</script>

<style lang="scss">
.login {
  display: flex;
  flex-flow: column nowrap;
  justify-content: flex-start;

  padding: 0.5em;
  align-self: stretch;

  color: $light-color;
  background: $primary-color;
}

input:focus {
  background: $light-color;
  color: $dark-color;

  outline: none;
}

.login_text {
  font-size: 1.5em;
  user-select: none;
}

.login_input {
  margin-top: 1em;
  background: #cccccc;
  color: $dark-color;

  border: none;
  border-radius: 0.3em;
  padding: 0.5em;
}

.login_button {
  align-self: flex-end;
  margin-top: 1em;

  padding: 0.5em;
  border-radius: 0.3em;

  background: $secondary-color;
  color: $light-color;
  border: none;

  cursor: pointer;
}
</style>
